update code formatting

This commit is contained in:
ksyasuda 2022-01-02 09:53:16 -08:00
parent 37f60ffb21
commit 55470e87e9
4 changed files with 522 additions and 564 deletions

600
ani-cli
View File

@ -34,7 +34,7 @@ c_reset="\033[0m"
help_text() { help_text() {
while IFS= read -r line; do while IFS= read -r line; do
printf "%s\n" "$line" printf "%s\n" "$line"
done <<-EOF done <<- EOF
USAGE: $prog <query> USAGE: $prog <query>
-h show this help text -h show this help text
-d download episode -d download episode
@ -58,22 +58,22 @@ log() {
search_anime() { search_anime() {
# get anime name along with its id # get anime name along with its id
log "NUM ARGS: $#" log "NUM ARGS: $#"
if [[ $# -gt 1 ]]; then if [[ $# -gt 1 ]]; then
# if multi-word query, concatenate into one string and replace spaces with '-' # if multi-word query, concatenate into one string and replace spaces with '-'
search="$*" search="$*"
search="${search// /-}" search="${search// /-}"
else else
# if one word, remove leading or trailing whitespace # if one word, remove leading or trailing whitespace
search="${1// /}" search="${1// /}"
fi fi
# search=${1// /-} # search=${1// /-}
log "Search Query: $search" log "Search Query: $search"
titlepattern='<a href="/category/' titlepattern='<a href="/category/'
curl -s "$BASE_URL//search.html" \ curl -s "$BASE_URL//search.html" \
-G \ -G \
-d "keyword=$search" | -d "keyword=$search" |
sed -n -E ' sed -n -E '
s_^[[:space:]]*<a href="/category/([^"]*)" title="([^"]*)".*_\1_p s_^[[:space:]]*<a href="/category/([^"]*)" title="([^"]*)".*_\1_p
' '
} }
@ -83,7 +83,7 @@ search_eps() {
anime_id=$1 anime_id=$1
curl -s "$BASE_URL/category/$anime_id" | curl -s "$BASE_URL/category/$anime_id" |
sed -n -E ' sed -n -E '
/^[[:space:]]*<a href="#" class="active" ep_start/{ /^[[:space:]]*<a href="#" class="active" ep_start/{
s/.* '\''([0-9]*)'\'' ep_end = '\''([0-9]*)'\''.*/\2/p s/.* '\''([0-9]*)'\'' ep_end = '\''([0-9]*)'\''.*/\2/p
q q
@ -92,10 +92,10 @@ search_eps() {
} }
check_input() { check_input() {
[ "$ep_choice_start" -eq "$ep_choice_start" ] 2>/dev/null || die "Invalid number entered" [ "$ep_choice_start" -eq "$ep_choice_start" ] 2> /dev/null || die "Invalid number entered"
episodes=$ep_choice_start episodes=$ep_choice_start
if [ -n "$ep_choice_end" ]; then if [ -n "$ep_choice_end" ]; then
[ "$ep_choice_end" -eq "$ep_choice_end" ] 2>/dev/null || die "Invalid number entered" [ "$ep_choice_end" -eq "$ep_choice_end" ] 2> /dev/null || die "Invalid number entered"
# create list of episodes to download/watch # create list of episodes to download/watch
episodes=$(seq $ep_choice_start $ep_choice_end) episodes=$(seq $ep_choice_start $ep_choice_end)
fi fi
@ -109,7 +109,7 @@ get_embedded_video_link() {
# credits to fork: https://github.com/Dink4n/ani-cli for the fix # credits to fork: https://github.com/Dink4n/ani-cli for the fix
# dub prefix takes the value "-dub" when dub is needed else is empty # dub prefix takes the value "-dub" when dub is needed else is empty
curl -s "$BASE_URL/$anime_id${dub_prefix}-episode-$ep_no" | curl -s "$BASE_URL/$anime_id${dub_prefix}-episode-$ep_no" |
sed -n -E ' sed -n -E '
/^[[:space:]]*<a href="#" rel="100"/{ /^[[:space:]]*<a href="#" rel="100"/{
s/.*data-video="([^"]*)".*/https:\1/p s/.*data-video="([^"]*)".*/https:\1/p
q q
@ -124,29 +124,29 @@ get_links() {
get_video_quality() { get_video_quality() {
get_links get_links
video_quality=$(curl -s get_links "$video_url" | grep -oE "(http|https):\/\/.*com\/cdn.*expiry=[0-9]*"| sort -V | sed 's/amp;//') video_quality=$(curl -s get_links "$video_url" | grep -oE "(http|https):\/\/.*com\/cdn.*expiry=[0-9]*" | sort -V | sed 's/amp;//')
case $quality in case $quality in
best) best)
play_link=$(echo "$video_quality" | sort -V | tail -n 1) play_link=$(echo "$video_quality" | sort -V | tail -n 1)
;; ;;
worst) worst)
play_link=$(echo "$video_quality" | sort -V | head -n 1) play_link=$(echo "$video_quality" | sort -V | head -n 1)
;; ;;
*) *)
play_link=$(echo "$video_quality" | grep -oE "(http|https):\/\/.*com\/cdn.*"${quality}".*expiry=[0-9]*") play_link=$(echo "$video_quality" | grep -oE "(http|https):\/\/.*com\/cdn.*"${quality}".*expiry=[0-9]*")
if [ -z "$play_link" ]; then if [ -z "$play_link" ]; then
printf "$c_red%s$c_reset\n" "Current video quality is not available (defaulting to highest quality)" >&2 printf "$c_red%s$c_reset\n" "Current video quality is not available (defaulting to highest quality)" >&2
quality=best quality=best
play_link=$(echo "$video_quality" | sort -V | tail -n 1) play_link=$(echo "$video_quality" | sort -V | tail -n 1)
fi fi
printf '%s' "$play_link" printf '%s' "$play_link"
;; ;;
esac esac
} }
dep_ch() { dep_ch() {
for dep; do for dep; do
if ! command -v "$dep" >/dev/null; then if ! command -v "$dep" > /dev/null; then
die "Program \"$dep\" not found. Please install it." die "Program \"$dep\" not found. Please install it."
fi fi
done done
@ -171,10 +171,10 @@ run_stmt() {
##################### #####################
check_db() { check_db() {
# Return number of matches for anime/episode in db # Return number of matches for anime/episode in db
# args: # args:
# $1: anime name: str # $1: anime name: str
# $2: either 'search' or 'watch' for which db to query # $2: either 'search' or 'watch' for which db to query
if [[ "$2" == "search" ]]; then if [[ "$2" == "search" ]]; then
stmt="SELECT DISTINCT COUNT(*) \ stmt="SELECT DISTINCT COUNT(*) \
FROM search_history \ FROM search_history \
@ -241,17 +241,17 @@ insert_history() {
sync_search_history() { sync_search_history() {
cnt=0 cnt=0
while read -r line; do while read -r line; do
anime_name=$(awk -F '|' '{print $2}' <<<"$line") anime_name=$(awk -F '|' '{print $2}' <<< "$line")
res=$(sqlite3 -noheader "$HISTORY_DB" "SELECT COUNT(*) FROM search_history WHERE anime_name = '$anime_name'") res=$(sqlite3 -noheader "$HISTORY_DB" "SELECT COUNT(*) FROM search_history WHERE anime_name = '$anime_name'")
if [[ "$res" -eq 0 ]]; then if [[ "$res" -eq 0 ]]; then
search_date=$(awk -F '|' '{print $3}' <<<"$line") search_date=$(awk -F '|' '{print $3}' <<< "$line")
log "Adding ($anime_name|$search_date) to search history..." log "Adding ($anime_name|$search_date) to search history..."
if ! sqlite3 "$HISTORY_DB" "INSERT INTO search_history(anime_name, search_date) VALUES('$anime_name', '$search_date')"; then if ! sqlite3 "$HISTORY_DB" "INSERT INTO search_history(anime_name, search_date) VALUES('$anime_name', '$search_date')"; then
err "Error inserting row $line" err "Error inserting row $line"
fi fi
((++cnt)) ((++cnt))
fi fi
done <<<"$(sqlite3 -noheader "$temp_db" "SELECT DISTINCT * FROM search_history")" done <<< "$(sqlite3 -noheader "$temp_db" "SELECT DISTINCT * FROM search_history")"
log "Inserted $cnt rows into search_history table" log "Inserted $cnt rows into search_history table"
} }
@ -265,14 +265,14 @@ sync_watch_history() {
# for each episode of $anime_name on the remote machine, check local # for each episode of $anime_name on the remote machine, check local
while read -r ep; do while read -r ep; do
# log "EP: $ep" # log "EP: $ep"
episode_num=$(awk -F '|' '{print $1}' <<<"$ep") episode_num=$(awk -F '|' '{print $1}' <<< "$ep")
# log "EPISODE NUMBER: $episode_num" # log "EPISODE NUMBER: $episode_num"
check_db "$anime_name" "$episode_num" check_db "$anime_name" "$episode_num"
num=$? num=$?
log "COUNT for $anime_name - episode $episode_num: $num" log "COUNT for $anime_name - episode $episode_num: $num"
if [[ "$num" -eq 0 ]]; then if [[ "$num" -eq 0 ]]; then
log "$anime_name - E$episode_num NOT IN DB" log "$anime_name - E$episode_num NOT IN DB"
watch_date=$(awk -F '|' '{print $NF}' <<<"$ep") watch_date=$(awk -F '|' '{print $NF}' <<< "$ep")
log "Adding ($anime_name|$episode_num|$watch_date) to watch history..." log "Adding ($anime_name|$episode_num|$watch_date) to watch history..."
if ! sqlite3 "$HISTORY_DB" "INSERT INTO watch_history(anime_name, episode_number, watch_date) VALUES('$anime_name', '$episode_num', '$watch_date')"; then if ! sqlite3 "$HISTORY_DB" "INSERT INTO watch_history(anime_name, episode_number, watch_date) VALUES('$anime_name', '$episode_num', '$watch_date')"; then
err "Error inserting row $ep" err "Error inserting row $ep"
@ -281,8 +281,8 @@ sync_watch_history() {
else else
log "$anime_name - Episode: $episode_num found in the db... skipping" log "$anime_name - Episode: $episode_num found in the db... skipping"
fi fi
done <<<"${episodes[@]}" done <<< "${episodes[@]}"
done <<<"$(sqlite3 -noheader "$temp_db" "SELECT DISTINCT anime_name FROM watch_history")" done <<< "$(sqlite3 -noheader "$temp_db" "SELECT DISTINCT anime_name FROM watch_history")"
log "Inserted $cnt rows into watch_history table" log "Inserted $cnt rows into watch_history table"
} }
@ -305,15 +305,15 @@ get_search_query() {
span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>" span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>"
if [ -z "$*" ] && [ "$is_rofi" -eq 1 ]; then if [ -z "$*" ] && [ "$is_rofi" -eq 1 ]; then
query=$(rofi -dmenu -l 12 -p "Search Anime:" \ query=$(rofi -dmenu -l 12 -p "Search Anime:" \
-mesg "$span" \ -mesg "$span" \
-config "$CFG_DIR/${ROFI_CFG}" <<< "${hist[@]}") -config "$CFG_DIR/${ROFI_CFG}" <<< "${hist[@]}")
# Remove the id from the query # Remove the id from the query
query="${query//[1-9]*\. /}" query="${query//[1-9]*\. /}"
# fixes '-' at end of selected anime, but removes spaces from queries # fixes '-' at end of selected anime, but removes spaces from queries
# works with trailing '-' so remove for now # works with trailing '-' so remove for now
# query="${query// /}" # query="${query// /}"
log "Query: $query" log "Query: $query"
elif [ "$is_rofi" -eq 0 ]; then elif [ "$is_rofi" -eq 0 ]; then
printf "Search Anime: " printf "Search Anime: "
read -r query read -r query
else else
@ -322,7 +322,7 @@ get_search_query() {
} }
# create history file # create history file
[ -f "$logfile" ] || : >"$logfile" [ -f "$logfile" ] || : > "$logfile"
##################### #####################
## Anime selection ## ## Anime selection ##
@ -340,7 +340,7 @@ anime_selection() {
idx=$((count - 1)) idx=$((count - 1))
res["$idx"]="$anime_id" res["$idx"]="$anime_id"
count=$((count + 1)) count=$((count + 1))
done <<-EOF done <<- EOF
$search_results $search_results
EOF EOF
@ -358,58 +358,58 @@ anime_selection() {
searched="$searched, $cnt" searched="$searched, $cnt"
fi fi
fi fi
((++cnt)) ((++cnt))
done done
log "SEARCHED: $searched" log "SEARCHED: $searched"
# get the anime from indexed list # get the anime from indexed list
msg="<span foreground='peachpuff' style='italic' size='small' weight='normal'>Query: $query</span>" msg="<span foreground='peachpuff' style='italic' size='small' weight='normal'>Query: $query</span>"
user_input=$(printf "${menu[@]}" | user_input=$(printf "${menu[@]}" |
rofi -dmenu -config "$CFG_DIR/${ROFI_CFG}" \ rofi -dmenu -config "$CFG_DIR/${ROFI_CFG}" \
-a "$searched" \ -a "$searched" \
-l 12 -i -p "Enter selection:" \ -l 12 -i -p "Enter selection:" \
-mesg "$msg") -mesg "$msg")
[ -z "$user_input" ] && return 1 [ -z "$user_input" ] && return 1
choice=$(printf '%s\n' "$user_input" | awk '{print $1}') choice=$(printf '%s\n' "$user_input" | awk '{print $1}')
# Remove period after number # Remove period after number
choice="${choice::-1}" choice="${choice::-1}"
name=$(printf '%s\n' "$user_input" | awk '{print $NF}') name=$(printf '%s\n' "$user_input" | awk '{print $NF}')
else else
menu_format_string='[%d] %s\n' menu_format_string='[%d] %s\n'
menu_format_string_c1="$c_blue[$c_cyan%d$c_blue] $c_reset%s\n" menu_format_string_c1="$c_blue[$c_cyan%d$c_blue] $c_reset%s\n"
menu_format_string_c2="$c_blue[$c_cyan%d$c_blue] $c_yellow%s$c_reset\n" menu_format_string_c2="$c_blue[$c_cyan%d$c_blue] $c_yellow%s$c_reset\n"
count=1 count=1
while read anime_id; do while read anime_id; do
# alternating colors for menu # alternating colors for menu
[ $((count % 2)) -eq 0 ] && [ $((count % 2)) -eq 0 ] &&
menu_format_string=$menu_format_string_c1 || menu_format_string=$menu_format_string_c1 ||
menu_format_string=$menu_format_string_c2 menu_format_string=$menu_format_string_c2
printf "$menu_format_string" "$count" "$anime_id" printf "$menu_format_string" "$count" "$anime_id"
count=$((count+1)) count=$((count + 1))
done <<< "$search_results" done <<< "$search_results"
# User input # User input
printf "$c_blue%s$c_green" "Enter number: " printf "$c_blue%s$c_green" "Enter number: "
read choice read choice
printf "$c_reset" printf "$c_reset"
name="$anime_id" name="$anime_id"
fi fi
log "CHOICE: $choice" log "CHOICE: $choice"
if [ "$is_rofi" -eq 1 ]; then if [ "$is_rofi" -eq 1 ]; then
log "NAME: $name" log "NAME: $name"
# check both choice and name are set # check both choice and name are set
if [[ ! "$choice" ]] || [[ ! "$name" ]]; then if [[ ! "$choice" ]] || [[ ! "$name" ]]; then
die "Invalid choice... committing seppuku" die "Invalid choice... committing seppuku"
fi fi
fi fi
# Check if input is a number # Check if input is a number
[ "$choice" -eq "$choice" ] 2>/dev/null || die "Invalid number entered" [ "$choice" -eq "$choice" ] 2> /dev/null || die "Invalid number entered"
# Select respective anime_id # Select respective anime_id
count=1 count=1
@ -419,19 +419,19 @@ anime_selection() {
break break
fi fi
count=$((count + 1)) count=$((count + 1))
done <<-EOF done <<- EOF
$search_results $search_results
EOF EOF
[ -z "$name" ] && name="$anime_id" [ -z "$name" ] && name="$anime_id"
log "NAME: $name" log "NAME: $name"
insert_history "$name" "search" insert_history "$name" "search"
printf "$c_reset" printf "$c_reset"
[ -z "$selection_id" ] && die "Invalid number entered" [ -z "$selection_id" ] && die "Invalid number entered"
read -r last_ep_number <<-EOF read -r last_ep_number <<- EOF
$(search_eps "$selection_id") $(search_eps "$selection_id")
EOF EOF
} }
@ -442,47 +442,47 @@ anime_selection() {
episode_selection() { episode_selection() {
ep_choice_start="1" ep_choice_start="1"
if [ "$is_rofi" -eq 1 ]; then if [ "$is_rofi" -eq 1 ]; then
# select episode number for anime # select episode number for anime
log "Anime ID: $anime_id" log "Anime ID: $anime_id"
stmt="SELECT DISTINCT episode_number \ stmt="SELECT DISTINCT episode_number \
FROM watch_history \ FROM watch_history \
WHERE anime_name = '$anime_id';" WHERE anime_name = '$anime_id';"
hist=$(run_stmt "$stmt") hist=$(run_stmt "$stmt")
log "HISTORY: ${hist[*]}" log "HISTORY: ${hist[*]}"
# Get Watch History for $anime_id as comma separated list # Get Watch History for $anime_id as comma separated list
watch_history="" watch_history=""
for i in $hist; do for i in $hist; do
if [[ "$watch_history" == "" ]]; then if [[ "$watch_history" == "" ]]; then
watch_history="$((--i))" watch_history="$((--i))"
else else
watch_history="$watch_history, $((--i))" watch_history="$watch_history, $((--i))"
fi fi
done done
log "WATCH HISTORY: %s\n" "$watch_history" log "WATCH HISTORY: %s\n" "$watch_history"
# get user choice and set the start and end # get user choice and set the start and end
msg='<span foreground="peachpuff" style="italic" size="small" weight="light">Range of episodes can be provided as: START_EPISODE - END_EPISODE</span>' msg='<span foreground="peachpuff" style="italic" size="small" weight="light">Range of episodes can be provided as: START_EPISODE - END_EPISODE</span>'
choice=$( choice=$(
seq 1 "$last_ep_number" | seq 1 "$last_ep_number" |
rofi -dmenu -l 12 \ rofi -dmenu -l 12 \
-a "$watch_history" \ -a "$watch_history" \
-p "Select Episode [1, $last_ep_number]:" \ -p "Select Episode [1, $last_ep_number]:" \
-mesg "$msg" \ -mesg "$msg" \
-config "$CFG_DIR/${ROFI_CFG}" -config "$CFG_DIR/${ROFI_CFG}"
) )
ep_choice_start=$(printf '%s\n' "${choice}" | awk '{print $1}') ep_choice_start=$(printf '%s\n' "${choice}" | awk '{print $1}')
ep_choice_end=$(printf '%s\n' "${choice}" | awk '{print $NF}') ep_choice_end=$(printf '%s\n' "${choice}" | awk '{print $NF}')
log "START: $ep_choice_start | END: $ep_choice_end" log "START: $ep_choice_start | END: $ep_choice_end"
elif [ $last_ep_number -gt 1 ]; then elif [ $last_ep_number -gt 1 ]; then
[ $is_download -eq 1 ] && [ $is_download -eq 1 ] &&
printf "Range of episodes can be specified: start_number end_number\n" printf "Range of episodes can be specified: start_number end_number\n"
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " $last_ep_number
read ep_choice_start ep_choice_end read ep_choice_start ep_choice_end
printf "$c_reset" printf "$c_reset"
fi fi
if [[ -z "$ep_choice_start" ]] && [[ -z "$ep_choice_end" ]]; then if [[ -z "$ep_choice_start" ]] && [[ -z "$ep_choice_end" ]]; then
die "No episode range entered" die "No episode range entered"
fi fi
@ -528,16 +528,16 @@ open_episode() {
fi fi
get_video_quality get_video_quality
status_code=$(curl -s -I get_video_quality "$play_link" | head -n 1|cut -d ' ' -f2) status_code=$(curl -s -I get_video_quality "$play_link" | head -n 1 | cut -d ' ' -f2)
log "Status code: $status_code" log "Status code: $status_code"
if [ "$is_download" -eq 0 ]; then if [ "$is_download" -eq 0 ]; then
if echo "$status_code" | grep -vE "^2.*"; then if echo "$status_code" | grep -vE "^2.*"; then
printf "${c_red}\nCannot reach servers!" printf "${c_red}\nCannot reach servers!"
else else
setsid -f $player_fn get_video_quality "$play_link" > /dev/null 2>&1 setsid -f $player_fn get_video_quality "$play_link" > /dev/null 2>&1
printf "${c_green}\nVideo playing" printf "${c_green}\nVideo playing"
fi fi
else else
log "Downloading episode $episode ..." log "Downloading episode $episode ..."
log "$video_url" log "$video_url"
@ -548,14 +548,14 @@ open_episode() {
mkdir -p "$anime_id" || die "Could not create directory" mkdir -p "$anime_id" || die "Could not create directory"
cd "$anime_id" || die "Could not enter subdirectory $ddir/$anime_id" cd "$anime_id" || die "Could not enter subdirectory $ddir/$anime_id"
# ffmpeg -i "$play_link" -c copy "${anime_id}-${episode}.mkv" >/dev/null 2>&1 && # ffmpeg -i "$play_link" -c copy "${anime_id}-${episode}.mkv" >/dev/null 2>&1 &&
if command -v "notify-send" >/dev/null; then if command -v "notify-send" > /dev/null; then
ffmpeg -i "$play_link" -c copy "${episode}.mkv" >/dev/null 2>&1 && ffmpeg -i "$play_link" -c copy "${episode}.mkv" > /dev/null 2>&1 &&
notify-send -i "$ANIWRAPPER_ICON_PATH" "Download complete for ${anime_id//-/ } - Episode: $episode" || notify-send -i "$ANIWRAPPER_ICON_PATH" "Download complete for ${anime_id//-/ } - Episode: $episode" ||
notify-send -i "$MAISAN_ICON_PATH" "Download failed for ${anime_id//-/ } - Episode: $episode. Please retry or check your internet connection" notify-send -i "$MAISAN_ICON_PATH" "Download failed for ${anime_id//-/ } - Episode: $episode. Please retry or check your internet connection"
else else
ffmpeg -i "$play_link" -c copy "${episode}.mkv" >/dev/null 2>&1 && ffmpeg -i "$play_link" -c copy "${episode}.mkv" > /dev/null 2>&1 &&
printf "${c_green}Downloaded complete for %s - Episode: %s${c_reset}\n" "${anime_id//-/ }" "$episode" || printf "${c_green}Downloaded complete for %s - Episode: %s${c_reset}\n" "${anime_id//-/ }" "$episode" ||
printf "${c_red}Download failed for %s - Episode: %s, please retry or check your internet connection${c_reset}\n" "${anime_id//-/ }" "$episode" printf "${c_red}Download failed for %s - Episode: %s, please retry or check your internet connection${c_reset}\n" "${anime_id//-/ }" "$episode"
fi fi
# printf "${c_green}Downloaded episode: %s${c_reset}\n" "$episode" || # printf "${c_green}Downloaded episode: %s${c_reset}\n" "$episode" ||
# printf "${c_red}Download failed episode: %s , please retry or check your internet connection${c_reset}\n" "$episode" # printf "${c_red}Download failed episode: %s , please retry or check your internet connection${c_reset}\n" "$episode"
@ -583,53 +583,53 @@ playlist_add=0
quality=best quality=best
while getopts 'hd:Hpa:P:svq:c' OPT; do while getopts 'hd:Hpa:P:svq:c' OPT; do
case "$OPT" in case "$OPT" in
h) h)
help_text help_text
exit 0 exit 0
;; ;;
d) d)
is_download=1 is_download=1
download_dir="$OPTARG" download_dir="$OPTARG"
log "DOWNLOAD DIR: $download_dir" log "DOWNLOAD DIR: $download_dir"
;; ;;
H) H)
scrape=history scrape=history
;; ;;
p) p)
scrape=playlist scrape=playlist
is_playlist=1 is_playlist=1
;; ;;
a) a)
is_add=1 is_add=1
scrape=add scrape=add
playlist_file="${OPTARG/ //}" playlist_file="${OPTARG/ //}"
;; ;;
P) P)
is_playlist=1 is_playlist=1
# remove spaces from $OPTARG # remove spaces from $OPTARG
playlist_file="${OPTARG/ //}" playlist_file="${OPTARG/ //}"
[ -z "$playlist_file" ] && die "Enter in path to playlist" [ -z "$playlist_file" ] && die "Enter in path to playlist"
log "$playlist_file" log "$playlist_file"
$player_fn "$playlist_file" $player_fn "$playlist_file"
exit 0 exit 0
;; ;;
s) s)
scrape=sync scrape=sync
;; ;;
v) v)
VERBOSE=1 VERBOSE=1
;; ;;
q) q)
quality="$OPTARG" quality="$OPTARG"
log "passed in quality: $quality" log "passed in quality: $quality"
;; ;;
c) c)
is_rofi=0 is_rofi=0
;; ;;
*) *)
printf "%s\n" "Invalid option" printf "%s\n" "Invalid option"
exit 1 exit 1
;; ;;
esac esac
done done
shift $((OPTIND - 1)) shift $((OPTIND - 1))
@ -639,125 +639,125 @@ shift $((OPTIND - 1))
######## ########
case $scrape in case $scrape in
query) query)
get_search_query "$*" get_search_query "$*"
searched=0 searched=0
if [ $# -eq 1 ]; then if [ $# -eq 1 ]; then
# check if anime has been searched before # check if anime has been searched before
anime_id="${query// /}" anime_id="${query// /}"
log "Checking if anime: $anime_id has been searched before..." log "Checking if anime: $anime_id has been searched before..."
check_db "$anime_id" "search" check_db "$anime_id" "search"
searched="$?" searched="$?"
log "Searched before: $searched" log "Searched before: $searched"
fi fi
if [ "$searched" -eq 0 ]; then if [ "$searched" -eq 0 ]; then
search_results=$(search_anime $query) search_results=$(search_anime $query)
[ -z "$search_results" ] && die "No search results found" [ -z "$search_results" ] && die "No search results found"
if ! anime_selection "$search_results"; then if ! anime_selection "$search_results"; then
die "No anime selection found" die "No anime selection found"
fi fi
else else
# if the query is a previous search # if the query is a previous search
# skip search_anime function and assign $query # skip search_anime function and assign $query
anime_id="${query// /}" anime_id="${query// /}"
selection_id="$anime_id" selection_id="$anime_id"
insert_history "$anime_id" "search" insert_history "$anime_id" "search"
read -r last_ep_number <<< "$(search_eps "$selection_id")" read -r last_ep_number <<< "$(search_eps "$selection_id")"
fi fi
episode_selection episode_selection
;; ;;
history) history)
stmt="SELECT DISTINCT anime_name FROM watch_history ORDER BY watch_date DESC" stmt="SELECT DISTINCT anime_name FROM watch_history ORDER BY watch_date DESC"
search_results=$(printf "%s\n" "$stmt" | sqlite3 -noheader "$HISTORY_DB") search_results=$(printf "%s\n" "$stmt" | sqlite3 -noheader "$HISTORY_DB")
[ -z "$search_results" ] && die "History is empty" [ -z "$search_results" ] && die "History is empty"
if ! anime_selection "${search_results[@]}"; then if ! anime_selection "${search_results[@]}"; then
die "No anime selection found" die "No anime selection found"
fi fi
log "SELECTION: $selection_id" log "SELECTION: $selection_id"
stmt="SELECT episode_number \ stmt="SELECT episode_number \
FROM watch_history \ FROM watch_history \
WHERE anime_name = '$selection_id' \ WHERE anime_name = '$selection_id' \
ORDER BY watch_date DESC \ ORDER BY watch_date DESC \
LIMIT 1" LIMIT 1"
ep_choice_start=$(run_stmt "$stmt") ep_choice_start=$(run_stmt "$stmt")
log "Most recently watched episode: $ep_choice_start" log "Most recently watched episode: $ep_choice_start"
;; ;;
playlist) playlist)
lines=$(wc -l <"$playlist_file") lines=$(wc -l < "$playlist_file")
log "Num lines in playlist: " "$lines" log "Num lines in playlist: " "$lines"
if [[ "$lines" -eq 0 ]]; then if [[ "$lines" -eq 0 ]]; then
get_search_query "$*"
search_results=$(search_anime "$query")
[ -z "$search_results" ] && die "No search results found"
if ! anime_selection "$search_results"; then
die "No anime selection found"
fi
episode_selection
else
line=($(sed '1q;d' "$playlist_file"))
if [[ "${#line[@]}" -ne 2 ]]; then
die "Something went wrong with the playlist file... exiting"
fi
selection_id="${line[0]}"
episodes=("$selection_id")
ep_choice_start="${line[1]}"
ep_choice_end=""
read -r last_ep_number <<- EOF
$(search_eps "$selection_id")
EOF
[ "$VERBOSE" -eq 1 ] && printf "Anime: %s Episode: %d\n" "$episodes" "$ep_choice_start"
[ "$VERBOSE" -eq 1 ] && printf "Episodes: %s\n" "${episodes[@]}"
fi
;;
add)
get_search_query "$*" get_search_query "$*"
search_results=$(search_anime "$query") search_results=$(search_anime "$query")
[ -z "$search_results" ] && die "No search results found" [ -z "$search_results" ] && die "No search results found"
if ! anime_selection "$search_results"; then anime_selection "$search_results"
die "No anime selection found" [ $? -ne 0 ] && die "No anime selection found"
fi
episode_selection episode_selection
else ;;
line=($(sed '1q;d' "$playlist_file")) sync)
if [[ "${#line[@]}" -ne 2 ]]; then printf "%s" "Enter username for remote user: "
die "Something went wrong with the playlist file... exiting" read -r username
printf "%s" "Enter host for remote user: "
read -r host
connection_str="$username@$host"
printf "%s" "Enter port to connect to remote host with or leave blank for default (22): "
read -r port
if [[ "${port/ //}" == "" ]]; then
PORT=22
else
PORT="$port"
fi fi
selection_id="${line[0]}"
episodes=("$selection_id")
ep_choice_start="${line[1]}"
ep_choice_end=""
read -r last_ep_number <<-EOF
$(search_eps "$selection_id")
EOF
[ "$VERBOSE" -eq 1 ] && printf "Anime: %s Episode: %d\n" "$episodes" "$ep_choice_start"
[ "$VERBOSE" -eq 1 ] && printf "Episodes: %s\n" "${episodes[@]}"
fi
;;
add)
get_search_query "$*"
search_results=$(search_anime "$query")
[ -z "$search_results" ] && die "No search results found"
anime_selection "$search_results"
[ $? -ne 0 ] && die "No anime selection found"
episode_selection
;;
sync)
printf "%s" "Enter username for remote user: "
read -r username
printf "%s" "Enter host for remote user: "
read -r host
connection_str="$username@$host" printf "%s" "Enter path to private key (leave blank if unsure or not needed): "
printf "%s" "Enter port to connect to remote host with or leave blank for default (22): " read -r key_path
read -r port
if [[ "${port/ //}" == "" ]]; then
PORT=22
else
PORT="$port"
fi
printf "%s" "Enter path to private key (leave blank if unsure or not needed): " printf "%s\n" "Syncing database with: $connection_str on port $PORT"
read -r key_path temp_db="/tmp/aniwrapper_tmp_history.sqlite3"
printf "%s\n" "Syncing database with: $connection_str on port $PORT" if [[ -z "$key_path" ]]; then
temp_db="/tmp/aniwrapper_tmp_history.sqlite3" scp -P "$PORT" "$connection_str:$XDG_CONFIG_HOME/aniwrapper/history.sqlite3" "$temp_db"
else
if [[ -z "$key_path" ]]; then scp -P "$PORT" -i "$key_path" "$connection_str:$XDG_CONFIG_HOME/aniwrapper/history.sqlite3" "$temp_db"
scp -P "$PORT" "$connection_str:$XDG_CONFIG_HOME/aniwrapper/history.sqlite3" "$temp_db" fi
else if [[ "$?" -ne 0 ]]; then
scp -P "$PORT" -i "$key_path" "$connection_str:$XDG_CONFIG_HOME/aniwrapper/history.sqlite3" "$temp_db" die "Error getting database file from remote host"
fi fi
if [[ "$?" -ne 0 ]]; then sync_search_history && sync_watch_history
die "Error getting database file from remote host" exit 0
fi ;;
sync_search_history && sync_watch_history
exit 0
;;
esac esac
{ # checking input { # checking input
[ "$ep_choice_start" -eq "$ep_choice_start" ] 2>/dev/null || die "Invalid number entered" [ "$ep_choice_start" -eq "$ep_choice_start" ] 2> /dev/null || die "Invalid number entered"
episodes=$ep_choice_start episodes=$ep_choice_start
if [ -n "$ep_choice_end" ]; then if [ -n "$ep_choice_end" ]; then
[ "$ep_choice_end" -eq "$ep_choice_end" ] 2>/dev/null || die "Invalid number entered" [ "$ep_choice_end" -eq "$ep_choice_end" ] 2> /dev/null || die "Invalid number entered"
# create list of episodes to download/watch # create list of episodes to download/watch
episodes=$(seq $ep_choice_start $ep_choice_end) episodes=$(seq $ep_choice_start $ep_choice_end)
fi fi
@ -768,7 +768,7 @@ for ep in $episodes; do
if [[ "$is_add" -eq 1 ]]; then if [[ "$is_add" -eq 1 ]]; then
log "ID: $selection_id" log "ID: $selection_id"
log "EPISODES: $episodes" log "EPISODES: $episodes"
printf "%s\n" "$selection_id $ep" >>"$playlist_file" printf "%s\n" "$selection_id $ep" >> "$playlist_file"
log "Added to playlist file" log "Added to playlist file"
else else
open_episode "$selection_id" "$ep" "$download_dir" open_episode "$selection_id" "$ep" "$download_dir"
@ -802,29 +802,29 @@ while :; do
printf "$c_reset" printf "$c_reset"
case $choice in case $choice in
n) n)
episode=$((episode + 1)) episode=$((episode + 1))
;; ;;
p) p)
episode=$((episode - 1)) episode=$((episode - 1))
;; ;;
s) s)
printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " "$last_ep_number" printf "${c_blue}Choose episode $c_cyan[1-%d]$c_reset:$c_green " "$last_ep_number"
read -r episode read -r episode
printf "$c_reset" printf "$c_reset"
[ "$episode" -eq "$episode" ] 2>/dev/null || die "Invalid number entered" [ "$episode" -eq "$episode" ] 2> /dev/null || die "Invalid number entered"
;; ;;
r) ;; r) ;;
q) q)
break break
;; ;;
*) *)
die "invalid choice" die "invalid choice"
;; ;;
esac esac
open_episode "$selection_id" "$episode" "$download_dir" open_episode "$selection_id" "$episode" "$download_dir"
done done

View File

@ -22,23 +22,22 @@ IS_DOWNLOAD=0
quit="6. Quit" quit="6. Quit"
options="1. Stream|2. Download|3. Continue|4. Play from File|5. Sync History|$quit" options="1. Stream|2. Download|3. Continue|4. Play from File|5. Sync History|$quit"
############# #############
# Functions # # Functions #
############# #############
get_quality() { get_quality() {
if [[ "$IS_ROFI" -eq 1 ]]; then if [[ "$IS_ROFI" -eq 1 ]]; then
selection=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \ selection=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Choose video quality:" -sep '|' <<< "$QUALITIES") -l 1 -p "Choose video quality:" -sep '|' <<< "$QUALITIES")
QUALITY=$(awk '{print $2}' <<< "$selection") QUALITY=$(awk '{print $2}' <<< "$selection")
else else
printf "%s" "Enter quality [ best | worst ]: " printf "%s" "Enter quality [ best | worst ]: "
read -r QUALITY read -r QUALITY
fi fi
log "selected quality: $QUALITY" log "selected quality: $QUALITY"
# if [[ "$QUALITY" != 'best' ]] && [[ "$QUALITY" != 'worst' ]]; then # if [[ "$QUALITY" != 'best' ]] && [[ "$QUALITY" != 'worst' ]]; then
# seppuku "Something went wrong getting the quality: $QUALITY... exiting" # seppuku "Something went wrong getting the quality: $QUALITY... exiting"
# fi # fi
} }
seppuku() { seppuku() {
@ -52,11 +51,11 @@ quit() {
} }
run() { run() {
if [[ "$GET_QUALITY" -eq 1 ]]; then if [[ "$GET_QUALITY" -eq 1 ]]; then
get_quality get_quality
else else
log "QUALITY flag not set... using default -> $QUALITY" log "QUALITY flag not set... using default -> $QUALITY"
fi fi
if [[ "$VERBOSE" -eq 0 ]]; then if [[ "$VERBOSE" -eq 0 ]]; then
"$CMD" -q "$QUALITY" "$*" "$CMD" -q "$QUALITY" "$*"
else else
@ -71,65 +70,50 @@ log() {
} }
playlist_mode() { playlist_mode() {
# --------------------------------------------------------------------------- # ---------------------------------------------------------------------------
# playlist mode # playlist mode
# --------------------------------------------------------------------------- # ---------------------------------------------------------------------------
log "Playlist mode"
options="1. Play playlist|2. Add to playlist|3. Delete from playlist|4. Quit"
choice=$(printf "%s\n" "${options[@]}" |
rofi -dmenu -sep '|' \
-config "$CFG_DIR/$CFG_FILE" -l 4 -i -p "Enter choice:")
[ -z "$choice" ] && seppuku "No choice selected"
[ "$choice" == "$quit" ] && quit
selection=$(printf "%s\n" "$choice" | awk '{ print $1 }')
if [[ "$selection" == "1." ]]; then
# ------------------------------------------------------------------
# watch playlist
# ------------------------------------------------------------------
log "Playlist mode" log "Playlist mode"
options="1. Play playlist|2. Add to playlist|3. Delete from playlist|4. Quit" options="1. From file|2. Streaming|3. Quit"
choice=$(printf "%s\n" "${options[@]}" | choice=$(printf "%s\n" "${options[@]}" |
rofi -dmenu -sep '|' \ rofi -dmenu -sep '|' \
-config "$CFG_DIR/$CFG_FILE" -l 4 -i -p "Enter choice:") -config "$CFG_DIR/$CFG_FILE" -l 4 -i -p "Enter choice:")
[ -z "$choice" ] && seppuku "No choice selected" [ -z "$choice" ] && seppuku "No choice selected"
[ "$choice" == "$quit" ] && quit [ "$choice" == "$quit" ] && quit
log "Selection: $choice"
selection=$(printf "%s\n" "$choice" | awk '{ print $1 }') selection=$(printf "%s\n" "$choice" | awk '{ print $1 }')
if [[ "$selection" == "1." ]]; then if [[ "$selection" == "1." ]]; then
# ------------------------------------------------------------------ # --------------------------------------------------------------
# watch playlist # watch playlist from file (downloaded videos)
# ------------------------------------------------------------------ # --------------------------------------------------------------
log "Playlist mode" log "Watching playlist from file"
options="1. From file|2. Streaming|3. Quit" PLAYLIST_DIR="$HOME/Videos/sauce"
choice=$(printf "%s\n" "${options[@]}" | log "Default playlist directory: $PLAYLIST_DIR"
rofi -dmenu -sep '|' \ choice=$(cd "$PLAYLIST_DIR" && find . -mindepth 1 -type d |
-config "$CFG_DIR/$CFG_FILE" -l 4 -i -p "Enter choice:") cut -c 3- |
rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" -l 5 -i -p "Choose playlist:")
[ -z "$choice" ] && seppuku "No choice selected" [ -z "$choice" ] && seppuku "No choice selected"
[ "$choice" == "$quit" ] && quit log "Choice" "$choice"
run -P "$PLAYLIST_DIR/$choice"
log "Selection: $choice"
selection=$(printf "%s\n" "$choice" | awk '{ print $1 }')
if [[ "$selection" == "1." ]]; then
# --------------------------------------------------------------
# watch playlist from file (downloaded videos)
# --------------------------------------------------------------
log "Watching playlist from file"
PLAYLIST_DIR="$HOME/Videos/sauce"
log "Default playlist directory: $PLAYLIST_DIR"
choice=$(cd "$PLAYLIST_DIR" && find . -mindepth 1 -type d |
cut -c 3- |
rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" -l 5 -i -p "Choose playlist:")
[ -z "$choice" ] && seppuku "No choice selected"
log "Choice" "$choice"
run -P "$PLAYLIST_DIR/$choice"
elif [[ "$selection" == "2." ]]; then
# --------------------------------------------------------------
# watch playlist of 'queued' videos to stream
# --------------------------------------------------------------
log "Watching from 'queue'"
choice=$(rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Enter path to playlist file (or leave blank for default):")
if [[ "$choice" ]]; then
PLAYLIST_FILE="$choice"
else
PLAYLIST_FILE="$DEFAULT_PLAYLIST"
fi
run -p
fi
elif [[ "$selection" == "2." ]]; then elif [[ "$selection" == "2." ]]; then
# ------------------------------------------------------------------ # --------------------------------------------------------------
# add to playlist # watch playlist of 'queued' videos to stream
# ------------------------------------------------------------------ # --------------------------------------------------------------
log "Add to playlist" log "Watching from 'queue'"
choice=$(rofi -dmenu \ choice=$(rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" \ -config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Enter path to playlist file (or leave blank for default):") -l 1 -p "Enter path to playlist file (or leave blank for default):")
@ -138,101 +122,115 @@ playlist_mode() {
else else
PLAYLIST_FILE="$DEFAULT_PLAYLIST" PLAYLIST_FILE="$DEFAULT_PLAYLIST"
fi fi
run -a "$PLAYLIST_FILE" run -p
elif [[ "$selection" == "3." ]]; then
# -----------------------------------------------------------------------
# delete from playlist
# -----------------------------------------------------------------------
log "Delete from playlist"
choice=$(rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Enter path to playlist file (or leave blank for default):")
if [[ "$choice" ]]; then
PLAYLIST_FILE="$choice"
else
PLAYLIST_FILE="$DEFAULT_PLAYLIST"
fi
[ "$VERBOSE" -eq 1 ] && log "playlist file: $PLAYLIST_FILE"
lines=""
cnt=0
while read -r line; do
if [[ "$cnt" -eq 0 ]]; then
lines="$((cnt + 1)). $line"
else
lines="$lines|$((cnt + 1)). $line"
fi
((cnt++))
done <"$PLAYLIST_FILE"
choice=$(rofi -dmenu -l 12 \
-sep '|' \
-config "$CFG_DIR/$CFG_FILE" -p "Choose episode to delete:" \
<<<"${lines[*]}")
log "choice: $choice"
selection=$(awk '{print $1}' <<<"$choice")
idx=${selection//\./}
log "index selected: $idx"
log "deleting entry: $idx"
if [[ -z "$idx" ]]; then
log "no entry selected"
exit 1
fi
sed -ie "$idx"d "$PLAYLIST_FILE"
if [ "$?" -eq 0 ]; then
log "$selection deleted from playlist"
exit 0
else
log "there was a problem deleting $choice"
exit 1
fi
fi fi
elif [[ "$selection" == "2." ]]; then
# ------------------------------------------------------------------
# add to playlist
# ------------------------------------------------------------------
log "Add to playlist"
choice=$(rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Enter path to playlist file (or leave blank for default):")
if [[ "$choice" ]]; then
PLAYLIST_FILE="$choice"
else
PLAYLIST_FILE="$DEFAULT_PLAYLIST"
fi
run -a "$PLAYLIST_FILE"
elif [[ "$selection" == "3." ]]; then
# -----------------------------------------------------------------------
# delete from playlist
# -----------------------------------------------------------------------
log "Delete from playlist"
choice=$(rofi -dmenu \
-config "$CFG_DIR/$CFG_FILE" \
-l 1 -p "Enter path to playlist file (or leave blank for default):")
if [[ "$choice" ]]; then
PLAYLIST_FILE="$choice"
else
PLAYLIST_FILE="$DEFAULT_PLAYLIST"
fi
[ "$VERBOSE" -eq 1 ] && log "playlist file: $PLAYLIST_FILE"
lines=""
cnt=0
while read -r line; do
if [[ "$cnt" -eq 0 ]]; then
lines="$((cnt + 1)). $line"
else
lines="$lines|$((cnt + 1)). $line"
fi
((cnt++))
done < "$PLAYLIST_FILE"
choice=$(rofi -dmenu -l 12 \
-sep '|' \
-config "$CFG_DIR/$CFG_FILE" -p "Choose episode to delete:" \
<<< "${lines[*]}")
log "choice: $choice"
selection=$(awk '{print $1}' <<< "$choice")
idx=${selection//\./}
log "index selected: $idx"
log "deleting entry: $idx"
if [[ -z "$idx" ]]; then
log "no entry selected"
exit 1
fi
sed -ie "$idx"d "$PLAYLIST_FILE"
if [ "$?" -eq 0 ]; then
log "$selection deleted from playlist"
exit 0
else
log "there was a problem deleting $choice"
exit 1
fi
fi
} }
play_file() { play_file() {
# opens the passed in file with $PLAYER_CMD # opens the passed in file with $PLAYER_CMD
log "Checking if file is playable" log "Checking if file is playable"
if [[ "$1" =~ (\.mp4|\.mkv|\.ts)$ ]]; then if [[ "$1" =~ (\.mp4|\.mkv|\.ts)$ ]]; then
log "File is playable..." log "File is playable..."
log "Playing file: $1" log "Playing file: $1"
if [[ "$VERBOSE" -eq 1 ]]; then if [[ "$VERBOSE" -eq 1 ]]; then
$PLAYER_CMD "$1" $PLAYER_CMD "$1"
else else
$PLAYER_CMD "$1" &>/dev/null & $PLAYER_CMD "$1" &> /dev/null &
fi fi
exit $? exit $?
else else
seppuku "File: $1 is not playable... Quitting" seppuku "File: $1 is not playable... Quitting"
fi fi
} }
check_path() { check_path() {
pth="$1" pth="$1"
if ! [ -d "$pth" ]; then if ! [ -d "$pth" ]; then
seppuku "ERROR: Passed in directory is not valid: $inp" seppuku "ERROR: Passed in directory is not valid: $inp"
elif [[ $(find "$pth" -type f | wc -l) -eq 0 ]]; then elif [[ $(find "$pth" -type f | wc -l) -eq 0 ]]; then
seppuku "ERROR: Passed in directory is empty: $inp" seppuku "ERROR: Passed in directory is empty: $inp"
fi fi
} }
find_videos() { find_videos() {
# recursive function for finding path to video file given a starting directory # recursive function for finding path to video file given a starting directory
inp="$1" inp="$1"
# log "INPUT: $inp" # log "INPUT: $inp"
if [ -f "$inp" ]; then if [ -f "$inp" ]; then
echo "$inp" echo "$inp"
return 0 return 0
fi fi
check_path "$inp" check_path "$inp"
selection=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \ selection=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \
-l 12 -i -p "Enter selection" <<< "$(ls "$inp")") -l 12 -i -p "Enter selection" <<< "$(ls "$inp")")
if [ -z "$selection" ]; then if [ -z "$selection" ]; then
seppuku "selection is empty... exiting" seppuku "selection is empty... exiting"
elif [ -d "$inp/$selection" ] || [ -f "$inp/$selection" ]; then elif [ -d "$inp/$selection" ] || [ -f "$inp/$selection" ]; then
find_videos "$inp/$selection" find_videos "$inp/$selection"
return $? return $?
fi fi
} }
######## ########
# Main # # Main #
######## ########
@ -244,18 +242,18 @@ while getopts 'vhqcd' OPT; do
v) v)
VERBOSE=1 VERBOSE=1
;; ;;
q) q)
GET_QUALITY=1 GET_QUALITY=1
log "Quality prompt enabled" log "Quality prompt enabled"
;; ;;
c) c)
IS_ROFI=0 IS_ROFI=0
log "Command-line (ani-cli) mode set" log "Command-line (ani-cli) mode set"
;; ;;
d) d)
IS_DOWNLOAD=1 IS_DOWNLOAD=1
log "Download flag set..." log "Download flag set..."
;; ;;
*) *)
log "Invalid option" log "Invalid option"
exit 1 exit 1
@ -267,14 +265,14 @@ log "CONFIG DIR: $CFG_DIR"
# Check if command-line flag is set # Check if command-line flag is set
if [[ "$IS_ROFI" -eq 0 ]] && [[ "$IS_DOWNLOAD" -eq 0 ]]; then if [[ "$IS_ROFI" -eq 0 ]] && [[ "$IS_DOWNLOAD" -eq 0 ]]; then
run -c run -c
exit $? exit $?
elif [[ "$IS_ROFI" -eq 0 ]] && [[ "$IS_DOWNLOAD" -eq 1 ]]; then elif [[ "$IS_ROFI" -eq 0 ]] && [[ "$IS_DOWNLOAD" -eq 1 ]]; then
printf "%s" "Enter download dir: " printf "%s" "Enter download dir: "
read -r dl_dir read -r dl_dir
log "Download dir: $dl_dir" log "Download dir: $dl_dir"
run "-cd $dl_dir" run "-cd $dl_dir"
exit $? exit $?
fi fi
choice=$(echo "${options[@]}" | rofi -dmenu -sep '|' \ choice=$(echo "${options[@]}" | rofi -dmenu -sep '|' \
@ -301,10 +299,10 @@ case "$selection" in
-l 1 -p "Enter download dir:") -l 1 -p "Enter download dir:")
# if dl_dir is none set to current directory # if dl_dir is none set to current directory
[ "$dl_dir" == "" ] && dl_dir="$DEFAULT_DOWNLOAD" [ "$dl_dir" == "" ] && dl_dir="$DEFAULT_DOWNLOAD"
# make sure download directory exists # make sure download directory exists
if [ ! -d "$DEFAULT_DOWNLOAD" ]; then if [ ! -d "$DEFAULT_DOWNLOAD" ]; then
mkdir -p "$DEFAULT_DOWNLOAD" mkdir -p "$DEFAULT_DOWNLOAD"
fi fi
run -d "$dl_dir" run -d "$dl_dir"
;; ;;
3.) 3.)
@ -322,14 +320,14 @@ case "$selection" in
msg="Enter path to the videos directory or leave blank to go with the default: $HOME/Videos/sauce/" msg="Enter path to the videos directory or leave blank to go with the default: $HOME/Videos/sauce/"
span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>" span="<span foreground='peachpuff' style='italic' size='small' weight='light'>$msg</span>"
play_dir=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \ play_dir=$(rofi -dmenu -config "$CFG_DIR/$CFG_FILE" \
-l 1 -mesg "$span" -p "Enter path to play dir:") -l 1 -mesg "$span" -p "Enter path to play dir:")
[ -z "$play_dir" ] && play_dir="$DEFAULT_DOWNLOAD" [ -z "$play_dir" ] && play_dir="$DEFAULT_DOWNLOAD"
log "PLAY DIR: $play_dir" log "PLAY DIR: $play_dir"
[ ! -d "$play_dir" ] && seppuku "$play_dir does not exist" [ ! -d "$play_dir" ] && seppuku "$play_dir does not exist"
video_path=$(find_videos "$play_dir") video_path=$(find_videos "$play_dir")
log "VIDEO PATH: $video_path" log "VIDEO PATH: $video_path"
if [ -z "$video_path" ]; then if [ -z "$video_path" ]; then
seppuku "Something went wrong getting path" seppuku "Something went wrong getting path"
fi fi
play_file "$video_path" play_file "$video_path"
;; ;;
@ -382,4 +380,3 @@ case "$selection" in
;; ;;
esac esac

51
db.sh
View File

@ -9,51 +9,12 @@ log() {
printf "%s\n" "$1" printf "%s\n" "$1"
} }
sync_search_history() {
cnt=0
temp_db="/tmp/aniwrapper_tmp_history.sqlite3"
while read -r line; do
anime_name=$(awk -F '|' '{print $2}' <<<"$line")
res=$(sqlite3 -noheader "$DIR/$DB" <<<"SELECT anime_name FROM search_history WHERE anime_name = '$anime_name'")
if [[ "${res/ //}" == "" ]]; then
log "Adding $line to search history..."
search_date=$(awk -F '|' '{print $3}' <<<"$line")
sqlite3 "$DIR/$DB" <<<"INSERT INTO search_history(anime_name, search_date) VALUES('$anime_name', '$search_date')"
if [[ "$?" -ne 0 ]]; then
log "Error inserting row $line"
fi
((++cnt))
fi
done <<<"$(sqlite3 -noheader "$temp_db" <<<"SELECT DISTINCT * FROM search_history")"
log "Inserted $cnt rows into search_history table"
}
sync_watch_history() {
cnt=0
temp_db="/tmp/aniwrapper_tmp_history.sqlite3"
while read -r line; do
anime_name=$(awk -F '|' '{print $2}' <<<"$line")
res=$(sqlite3 -noheader "$DIR/$DB" <<<"SELECT anime_name FROM watch_history WHERE anime_name = '$anime_name'")
if [[ "${res/ //}" == "" ]]; then
log "Adding $line to watch history..."
episode_num=$(awk -F '|' '{print $3}' <<<"$line")
watch_date=$(awk -F '|' '{print $NF}' <<<"$line")
sqlite3 "$DIR/$DB" <<<"INSERT INTO watch_history(anime_name, episode_number, watch_date) VALUES('$anime_name', '$episode_num', '$watch_date')"
if [[ "$?" -ne 0 ]]; then
log "Error inserting row $line"
fi
((++cnt))
fi
done <<<"$(sqlite3 -noheader "$temp_db" <<<"SELECT DISTINCT * FROM watch_history")"
log "Inserted $cnt rows into watch_history table"
}
while getopts 'cdrqCs' OPT; do while getopts 'cdrqCs' OPT; do
case "$OPT" in case "$OPT" in
c) c)
log "Creating database..." log "Creating database..."
sqlite3 "$DIR"/"$DB" <sql/search_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/search_history_tbl.sql
sqlite3 "$DIR"/"$DB" <sql/watch_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/watch_history_tbl.sql
log "Created database..." log "Created database..."
;; ;;
d) d)
@ -69,8 +30,8 @@ while getopts 'cdrqCs' OPT; do
mkdir -p "$DIR" mkdir -p "$DIR"
log "Database deleted..." log "Database deleted..."
log "Creating database..." log "Creating database..."
sqlite3 "$DIR"/"$DB" <sql/search_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/search_history_tbl.sql
sqlite3 "$DIR"/"$DB" <sql/watch_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/watch_history_tbl.sql
log "Created database..." log "Created database..."
;; ;;
q) q)
@ -82,10 +43,10 @@ while getopts 'cdrqCs' OPT; do
log "Cleaning up database..." log "Cleaning up database..."
stmt="DELETE FROM search_history WHERE anime_name IS NULL OR anime_name = ''" stmt="DELETE FROM search_history WHERE anime_name IS NULL OR anime_name = ''"
log "Cleaning up search history..." log "Cleaning up search history..."
sqlite3 "$DIR/$DB" <<<"$stmt" sqlite3 "$DIR/$DB" <<< "$stmt"
stmt="DELETE FROM watch_history WHERE anime_name IS NULL OR anime_name = '' OR episode_number = 0" stmt="DELETE FROM watch_history WHERE anime_name IS NULL OR anime_name = '' OR episode_number = 0"
log "Cleaning up watch history..." log "Cleaning up watch history..."
sqlite3 "$DIR/$DB" <<<"$stmt" sqlite3 "$DIR/$DB" <<< "$stmt"
;; ;;
s) s)
printf "%s" "Enter connection string for remote user in the form user@host: " printf "%s" "Enter connection string for remote user in the form user@host: "

View File

@ -11,16 +11,16 @@ DB="history.sqlite3"
# Set the XDG_CONFIG_HOME locally if not set # Set the XDG_CONFIG_HOME locally if not set
if [[ -z "$XDG_CONFIG_HOME" ]]; then if [[ -z "$XDG_CONFIG_HOME" ]]; then
XDG_CONFIG_HOME="$HOME/.config" XDG_CONFIG_HOME="$HOME/.config"
fi fi
DIR="$XDG_CONFIG_HOME/aniwrapper" DIR="$XDG_CONFIG_HOME/aniwrapper"
MPV_DIR="$XDG_CONFIG_HOME/mpv" MPV_DIR="$XDG_CONFIG_HOME/mpv"
log() { log() {
if [[ "$VERBOSE" -eq 1 ]]; then if [[ "$VERBOSE" -eq 1 ]]; then
printf "%s\n" "$*" printf "%s\n" "$*"
fi fi
} }
# executes aniwrapper setup # executes aniwrapper setup
@ -30,52 +30,52 @@ log() {
# 4. move skip-intro.lua into mpv/scripts folder # 4. move skip-intro.lua into mpv/scripts folder
# 5. move the aniwrapper icon to $XDG_CONFIG_HOME/aniwrapper/ directory # 5. move the aniwrapper icon to $XDG_CONFIG_HOME/aniwrapper/ directory
run_setup() { run_setup() {
log "INSTALL DIR: $DIR" log "INSTALL DIR: $DIR"
if [[ ! -d "$DIR" ]]; then if [[ ! -d "$DIR" ]]; then
log "Creating directory $DIR" log "Creating directory $DIR"
mkdir -p "$DIR" mkdir -p "$DIR"
log "Directory created" log "Directory created"
fi fi
if [[ ! -f "$DIR"/"$DB" ]]; then if [[ ! -f "$DIR"/"$DB" ]]; then
# Create the DB if not exists # Create the DB if not exists
log "Creating history database..." log "Creating history database..."
sqlite3 "$DIR"/"$DB" <sql/watch_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/watch_history_tbl.sql
sqlite3 "$DIR"/"$DB" <sql/search_history_tbl.sql sqlite3 "$DIR"/"$DB" < sql/search_history_tbl.sql
log "History database created..." log "History database created..."
fi fi
if [[ ! -f "$DIR/meh.rasi" ]]; then if [[ ! -f "$DIR/meh.rasi" ]]; then
# Move theme files and skip-intro script to correct locations # Move theme files and skip-intro script to correct locations
log "Moving theme files..." log "Moving theme files..."
cp themes/* "$DIR"/ cp themes/* "$DIR"/
log "Theme files moved..." log "Theme files moved..."
fi fi
log "Creating mpv/scripts/ directory if it doesn't exist..." log "Creating mpv/scripts/ directory if it doesn't exist..."
mkdir -p "$MPV_DIR/scripts/" mkdir -p "$MPV_DIR/scripts/"
if [[ ! -f "$MPV_DIR/scripts/skip-intro.lua" ]]; then if [[ ! -f "$MPV_DIR/scripts/skip-intro.lua" ]]; then
log "Moving skip-intro.lua into mpv scripts directory..." log "Moving skip-intro.lua into mpv scripts directory..."
cp lua/skip-intro.lua "$MPV_DIR/scripts/" cp lua/skip-intro.lua "$MPV_DIR/scripts/"
log "Moved skip-intro.lua into scripts directory..." log "Moved skip-intro.lua into scripts directory..."
else else
log "skip-intro.lua already exists in $XDG_CONFIG_HOME/mpv/scripts/" log "skip-intro.lua already exists in $XDG_CONFIG_HOME/mpv/scripts/"
fi fi
if [[ ! -d "$DIR/icons" ]]; then if [[ ! -d "$DIR/icons" ]]; then
log "Creating icons directory" log "Creating icons directory"
mkdir -p "$DIR/icons" mkdir -p "$DIR/icons"
fi fi
# install aniwrapper icons # install aniwrapper icons
cp .assets/icons/* "$DIR/icons/" cp .assets/icons/* "$DIR/icons/"
log "Installed icons in config directory..." log "Installed icons in config directory..."
# xdg-icon-resource install --size 64 ./assets/icons/icon-64.png aniwrapper --novendor # xdg-icon-resource install --size 64 ./assets/icons/icon-64.png aniwrapper --novendor
} }
if run_setup; then if run_setup; then
log "Setup Complete...." log "Setup Complete...."
else else
printf "%s\n" "There was an error during setup" printf "%s\n" "There was an error during setup"
exit 1 exit 1
fi fi